#ifndef PLUGIN_AUDISP2FILE_H
#define PLUGIN_AUDISP2FILE_H 1

#include "evnt.h"
#include "vlg.h"
#include "opt_serv.h"
#include "opt_policy.h"

#define AUDISP2FILE_CONF_MAX_WAIT_SEND 16

#define AUDISP2FILE_CONF_RECV_CALL_LIMIT 4
#define AUDISP2FILE_CONF_SEND_CALL_LIMIT 1

#define AUDISP2FILE_CONF_DEF_LISTEN "/var/run/audit_events"
#define AUDISP2FILE_CONF_DEF_USR_LISTEN "./audit_events"

typedef struct Audisp2file_policy_opts
{
 Opt_serv_policy_opts s[1];

 unsigned int max_header_sz;
} Audisp2file_policy_opts;

typedef struct Audisp2file_opts
{
 Opt_serv_opts s[1];
 
 time_t beg_time;
 
 Conf_parse *conf;
 unsigned int conf_num;

 Vstr_base *main_input;

 Conf_token match_connection[1];
 Conf_token tmp_match_connection[1];
 Conf_token match_audit_line[1];
 Conf_token tmp_match_audit_line[1];
} Audisp2file_opts;
#define AUDISP2FILE_CONF_DECL_OPTS(N)                               \
    Audisp2file_opts N[1] = {                                       \
     {                                                          \
      {{OPT_SERV_CONF_INIT_OPTS(PACKAGE, VERSION)}},            \
      (time_t)-1,                                               \
      NULL,                                                     \
      0,                                                        \
      NULL,                                                     \
      {CONF_TOKEN_INIT},                                        \
      {CONF_TOKEN_INIT},                                        \
      {CONF_TOKEN_INIT},                                        \
      {CONF_TOKEN_INIT},                                        \
     }                                                          \
    }

struct Con
{
 struct Evnt evnt[1];

 Vstr_base *tag;
 
 const Audisp2file_policy_opts *policy;

 unsigned int io_limit_num : 8;

 struct Con *prev;
 struct Con *next;
};
#define CON_CEVNT_SA(x)     EVNT_SA((x)->evnt)
#define CON_CEVNT_SA_IN4(x) EVNT_SA_IN4((x)->evnt)
#define CON_CEVNT_SA_IN6(x) EVNT_SA_IN6((x)->evnt)
#define CON_CEVNT_SA_UN(x)  EVNT_SA_UN((x)->evnt)

#define CON_SEVNT_SA(x)     EVNT_ACPT_SA((x)->evnt)
#define CON_SEVNT_SA_IN4(x) EVNT_ACPT_SA_IN4((x)->evnt)
#define CON_SEVNT_SA_IN6(x) EVNT_ACPT_SA_IN6((x)->evnt)
#define CON_SEVNT_SA_UN(x)  EVNT_ACPT_SA_UN((x)->evnt)

#ifdef AUDISP2FILE_HAVE_GLOBAL_OPTS
extern Audisp2file_opts audisp2file_opts[1]; /* hacky ... */
#endif

#include "plugin-audisp2file_conf.h"

#endif
